﻿Imports System.ComponentModel

Namespace ViewModel

    Public MustInherit Class ViewModelBase
        Implements IDisposable
        Implements INotifyPropertyChanged

        Public Shared Counter As Integer = 1
        Public Nummer As String

        Public Sub New()
            Counter += 1
            Init()
        End Sub

        Protected Sub Init()
            If DesignerProperties.GetIsInDesignMode(New System.Windows.DependencyObject()) Then
                InitDesigntime()
            Else
                InitRuntime()
            End If
        End Sub

        Protected Overridable Sub InitRuntime()

        End Sub

        Protected Overridable Sub InitDesigntime()

        End Sub


#Region "INotifyPropertyChanged"

        Public Event PropertyChanged(sender As Object, e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

        ''' <summary>
        ''' Methode ruft das Propertychanged-Event auf
        ''' </summary>
        ''' <param name="PropertyName">Name der Property</param>
        ''' <remarks></remarks>
        Protected Sub OnPropertychanged(PropertyName As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(PropertyName))
        End Sub

#End Region

#Region "Properties"
        Private _DisplayName As String
        Public Property DisplayName() As String
            Get
                Return _DisplayName
            End Get
            Set(ByVal value As String)
                If value <> _DisplayName Then
                    _DisplayName = value
                    OnPropertychanged("DisplayName")
                End If
            End Set
        End Property

#End Region

#Region "IDisposable Member"
        Protected disposed As Boolean ' So ermitteln Sie überflüssige Aufrufe

        ' IDisposable
        Protected Overridable Sub Dispose(disposing As Boolean)
            If Not Me.disposed Then
                If disposing Then
                    ' TODO: Verwalteten Zustand löschen (verwaltete Objekte).
                End If
                ' TODO: Nicht verwaltete Ressourcen (nicht verwaltete Objekte) freigeben und Finalize() unten überschreiben.
                ' TODO: Große Felder auf NULL festlegen.
            End If
            Me.disposed = True
        End Sub

        ' TODO: Finalize() nur überschreiben, wenn Dispose(ByVal disposing As Boolean) oben über Code zum Freigeben von nicht verwalteten Ressourcen verfügt.
        'Protected Overrides Sub Finalize()
        '    ' Ändern Sie diesen Code nicht. Fügen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
        '    Dispose(False)
        '    MyBase.Finalize()
        'End Sub

        ' Dieser Code wird von Visual Basic hinzugefügt, um das Dispose-Muster richtig zu implementieren.
        Public Sub Dispose() Implements IDisposable.Dispose
            ' Ändern Sie diesen Code nicht. Fügen Sie oben in Dispose(ByVal disposing As Boolean) Bereinigungscode ein.
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub
#End Region


    End Class
End Namespace
