﻿Imports MVVM.Model
Imports MVVM.View
Imports System.Collections.ObjectModel
Imports System.ComponentModel

Namespace ViewModel

    Public Class ColorViewModel
        Inherits WorkspaceViewModel

        Private Property Color As Color
            Get
                Return Pinsel.Color
            End Get
            Set(value As Color)
                If value <> Pinsel.Color Then
                    Pinsel.Color = value
                    OnPropertychanged("Color")
                End If
            End Set
        End Property
        Public Property A As Single
            Get
                Return Color.ScA
            End Get
            Set(value As Single)
                If value <> Color.ScA Then
                    Color = Color.FromScRgb(value, Color.ScR, Color.ScG, Color.ScB)
                End If
            End Set
        End Property

        Public Property R As Single
            Get
                Return Color.ScR
            End Get
            Set(value As Single)
                If value <> Color.ScR Then
                    Color = Color.FromScRgb(Color.ScA, value, Color.ScG, Color.ScB)
                End If
            End Set
        End Property

        Public Property G As Single
            Get
                Return Color.ScG
            End Get
            Set(value As Single)
                If value <> Color.ScG Then
                    Color = Color.FromScRgb(Color.ScA, Color.ScR, value, Color.ScB)
                End If
            End Set
        End Property

        Public Property B As Single
            Get
                Return Color.ScB
            End Get
            Set(value As Single)
                If value <> Color.ScB Then
                    Color = Color.FromScRgb(Color.ScA, Color.ScR, Color.ScG, value)
                End If
            End Set
        End Property

        Private _pinsel As New SolidColorBrush
        Public Property Pinsel As SolidColorBrush
            Get
                Return _pinsel
            End Get
            Set(value As SolidColorBrush)
                _pinsel = value

                OnPropertychanged("Pinsel")
            End Set
        End Property

        Public Sub New()
            Pinsel.Color = Colors.Yellow
        End Sub
    End Class
End Namespace
